VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1980
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   1980
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   1800
      TabIndex        =   2
      Top             =   600
      Width           =   1215
   End
   Begin VB.TextBox txtValue 
      Height          =   285
      Left            =   1800
      MaxLength       =   11
      TabIndex        =   1
      Text            =   "12345678.98"
      Top             =   240
      Width           =   1935
   End
   Begin VB.Label lblMoney 
      Height          =   615
      Left            =   240
      TabIndex        =   3
      Top             =   1200
      Width           =   4215
   End
   Begin VB.Label Label1 
      Caption         =   "Value"
      Height          =   255
      Left            =   1200
      TabIndex        =   0
      Top             =   240
      Width           =   495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Code by Bill Hileman <bhileman@dasi-software.com>.
Public Function VerbalDollar(curAmount As Currency) As String

  Const strHundred = "Hundred"
  Const strThousand = "Thousand"
  Const strMillion = "Million"
  Const strDollars = "Dollars"
  Const strAnd = "And"
  Const strHundredths = "/100"
  
  Dim varDigit As Variant
  
  Dim strVerbal As String
  Dim strNumber As String
  
  Dim intCnt1 As Integer
  Dim intCnt2 As Integer
  Dim intMillions As Integer
  Dim intThousands As Integer
  Dim intHundreds As Integer
  Dim intTens As Integer

  On Error GoTo VerbalDollar_Error

  varDigit = Array("Zero", "One", "Two", "Three", "Four", "Five", "Six", "Seven", _
                   "Eight", "Nine", "Ten", "Eleven", "Twelve", "Thirteen", "Fourteen", _
                   "Fifteen", "Sixteen", "Seventeen", "Eighteen", "Nineteen", "Twenty")
                   
  ReDim Preserve varDigit(99)
  
  varDigit(30) = "Thirty"
  varDigit(40) = "Forty"
  varDigit(50) = "Fifty"
  varDigit(60) = "Sixty"
  varDigit(70) = "Seventy"
  varDigit(80) = "Eighty"
  varDigit(90) = "Ninety"
  
  For intCnt1 = 20 To 90 Step 10
    For intCnt2 = 1 To 9
      varDigit(intCnt1 + intCnt2) = varDigit(intCnt1) & "-" & StrConv(varDigit(intCnt2), vbLowerCase)
    Next intCnt2
  Next intCnt1
  
  strVerbal = ""
  
  strNumber = Format$(Format$(curAmount, "#######0.00"), "@@@@@@@@@@@")
  
  intMillions = Val(Left$(strNumber, 2))
  
  If intMillions <> 0 Then
    strVerbal = varDigit(intMillions) & " " & strMillion & " "
  End If
  
  intThousands = Val(Mid$(strNumber, 3, 3))
  
  If intThousands <> 0 Then
    intHundreds = Val(Mid$(strNumber, 3, 1))
    If intHundreds <> 0 Then
      strVerbal = strVerbal & varDigit(intHundreds) & " " & strHundred & " "
    End If
    intTens = Val(Mid$(strNumber, 4, 2))
    If intTens <> 0 Then
      strVerbal = strVerbal & varDigit(intTens) & " "
    End If
    strVerbal = strVerbal & strThousand & " "
  End If
  
  intHundreds = Val(Mid$(strNumber, 6, 1))
  
  If intHundreds <> 0 Then
    strVerbal = strVerbal & varDigit(intHundreds) & " " & strHundred & " "
  End If
  
  intTens = Val(Mid$(strNumber, 7, 2))
  
  If intTens <> 0 Then
    strVerbal = strVerbal & varDigit(intTens) & " "
  End If
  
  If strVerbal = "" Then
    strVerbal = varDigit(0) & " "
  End If
  
  strVerbal = strVerbal & strAnd & " " & Right$(strNumber, 2) & strHundredths & " " & strDollars
  
  VerbalDollar = strVerbal

  On Error GoTo 0
  Exit Function

VerbalDollar_Error:

  MsgBox "Error " & Err.Number & " (" & Err.Description & _
         ") in procedure VerbalDollar of Module mDASIGlobal"

End Function

Private Sub cmdGo_Click()
Dim num As Currency

    On Error GoTo BadNumber

    num = CCur(txtValue.Text)
    If num >= 100000000 Then
        MsgBox "The value must be less than 100 million", _
            vbCritical
        txtValue.SetFocus
    Else
        lblMoney.Caption = VerbalDollar(num)
    End If
    Exit Sub

BadNumber:
    MsgBox "The value must be a numeric currency value", _
        vbCritical
    txtValue.SetFocus
End Sub

